/*
 * Copyright (c) 2018, Mellanox Technologies. All rights reserved.
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
#ifndef __GPIO_MLXBF_REGS_H__
#define __GPIO_MLXBF_REGS_H__

#ifdef __ASSEMBLER__
#define _64bit(x) x
#else /* __ASSEMBLER__ */
#ifdef __tile__
#define _64bit(x) x ## UL
#else /* __tile__ */
#define _64bit(x) x ## ULL
#endif /* __tile__ */
#endif /* __ASSEMBLER */

#ifdef __KERNEL__
#include <linux/types.h>
#else
#include <stdint.h>
#endif

#ifndef __DOXYGEN__

#define GPIO_INT_SETUP 0x40
#define GPIO_INT_SETUP__LENGTH 0x0001
#define GPIO_INT_SETUP__GBL_ENA_SHIFT 0
#define GPIO_INT_SETUP__GBL_ENA_WIDTH 1
#define GPIO_INT_SETUP__GBL_ENA_RESET_VAL 0
#define GPIO_INT_SETUP__GBL_ENA_RMASK 0x1
#define GPIO_INT_SETUP__GBL_ENA_MASK  0x1
#define GPIO_INT_SETUP__BASE_INT_NUM_SHIFT 48
#define GPIO_INT_SETUP__BASE_INT_NUM_WIDTH 16
#define GPIO_INT_SETUP__BASE_INT_NUM_RMASK 0xffff
#define GPIO_INT_SETUP__BASE_INT_NUM_MASK  _64bit(0xffff000000000000)

#define GPIO_PIN_DIR_I 0x1040

#define GPIO_PIN_DIR_O 0x1048

#define GPIO_SCRATCHPAD 0x20

#endif /* !defined(__DOXYGEN__) */
#endif /* !defined(__GPIO_MLXBF_REGS_H__) */
